%
% csenal.m
%
%  Programa para la seleccin del caso de estudio
%  se considera:
%                falta interna o externa
%                Inrush
%                Instante de conexion del transformador
%                Resistencia de falta
%
function [irele,t]=csenal(vent1,ejes_red,ejes_senal,in_state,falta_state,an_f,res_f,...
xw,yw,tipo_w,nro_nivel,nro_w,ejes_wave,ejes_detalle,ejes_cri,ejes_fourier)

%Crea ejes para dibujar seal

set(ejes_senal,'Visible','off');
axes(ejes_senal);
cla;
for i=1:length(ejes_wave)
   set(ejes_wave(i),'Visible','off');
   axes(ejes_wave(i));
   cla;
end
set(ejes_detalle,'Visible','off');
   axes(ejes_detalle);
   cla;
set(ejes_cri,'Visible','off');
   axes(ejes_cri);
   cla;
set(ejes_fourier,'Visible','off');
axes(ejes_fourier);
cla;
   
if in_state==1
   switch an_f
      case 1                                   % Inrush = 0 sin Fi, sin Fe 
         if falta_state==1
            disp('solo inrush')
            casos=1;
            dibuja_mono(ejes_red,'inrush.jpg');
              clear irele;
              load in0gr;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

         elseif falta_state==0
             dibuja_mono(ejes_red,'infalin.jpg');
         switch res_f
         case 1                               % Inrush= 0 y Fi con Rf=0
            casos=2;
              clear irele;
              load in0f0;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

         case 2                               % Inrush= 0 y Fi con Rf=0.01  
            casos=3;
              clear irele;
              load in0f001;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

         case 3                               % Inrush= 0 y Fi con Rf=1.0
            casos=4;
              clear irele;
              load in0f1;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

         case 4                               % Inrush= 0 y Fi con Rf=100
            casos=5;
              clear irele;
              load in0f100;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

         end   
       disp('falta interna+in')
    else
         dibuja_mono(ejes_red,'infalex.jpg');
       switch res_f
       case 1                %Rf = 0
          casos=6;
              clear irele;
              load i0fe0;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 2                %Rf = 0.01
          casos=7;
              clear irele;
              load i0fe001;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 3                %Rf = 1.0
          casos=8;
              clear irele;
              load i0fe1;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 4
          casos=9;           %Rf = 100
              clear irele;
              load i0fe100;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

         end   
       disp('falta externa+ in')
    end
      case 2                          % Inrush para 30
    if falta_state==1
       disp('solo inrush')
       casos=10;
       dibuja_mono(ejes_red,'inrush.jpg');
              clear irele;
              load in30gr;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

    elseif falta_state==0
     dibuja_mono(ejes_red,'infalin.jpg');
       switch res_f
       case 1
          casos=11;
              clear irele;
              load in30f0;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 2
          casos=12;
              clear irele;
              load in30f001;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 3
          casos=13;
              clear irele;
              load in30f1;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 4
          casos=14;
              clear irele;
              load in30f100;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

         end   
       disp('falta interna+in')
    else
        dibuja_mono(ejes_red,'infalex.jpg');
       switch res_f
       case 1
          casos=15;
              clear irele;
              load i30fe0;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 2
          casos=16;
              clear irele;
              load i30fe001;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 3
          casos=17;
              clear irele;
              load i30fe1;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 4
          casos=18;
              clear irele;
              load i30fe100;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

         end   
       disp('falta externa+ in')
    end
       case 3                               % Inrush para 60
    if falta_state==1
       disp('solo inrush')
       dibuja_mono(ejes_red,'inrush.jpg');
       casos=19;
              clear irele;
              load in60gr;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 
    elseif falta_state==0
        dibuja_mono(ejes_red,'infalin.jpg');
       switch res_f
       case 1
          casos=20;
              clear irele;
              load in60f0;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 2
          casos=21;
              clear irele;
              load in60f001;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 3
          casos=22;
              clear irele;
              load in60f1;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 4
          casos=23;
              clear irele;
              load in60f100;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

         end   
       disp('falta interna+in')
    else
       dibuja_mono(ejes_red,'infalex.jpg');
       switch res_f
       case 1
          casos=24;
              clear irele;
              load i60fe0;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 2
          casos=25;
              clear irele;
              load i60fe001;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 3
          casos=26;
              clear irele;
              load i60fe1;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 4
          casos=27;
              clear irele;
              load i60fe100;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

         end   
       disp('falta externa+ in')
    end
        case 4                         % Inrush para 90
           if falta_state==1
              casos=28
              dibuja_mono(ejes_red,'inrush.jpg');
              disp('solo inrush')
              clear irele;
              load in90gr;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 
            elseif falta_state==0
        dibuja_mono(ejes_red,'infalin.jpg');
       switch res_f
       case 1
          casos=29;
              clear irele;
              load in90f0;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 2
          casos=30;
              clear irele;
              load in90f001;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 3
          casos=31;
              clear irele;
              load in90f1;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 4
          casos=32;
              clear irele;
              load in90f100;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

         end   
       disp('falta interna+in')
    else
        dibuja_mono(ejes_red,'infalex.jpg');
       switch res_f
       case 1
          casos=33;
              clear irele;
              load i90fe0;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 2
          casos=34;
              clear irele;
              load i90fe001;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 3
          casos=35;
              clear irele;
              load i90fe1;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 
          case 4
          casos=36;
              clear irele;
              load i90fe100;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

         end   
       disp('falta externa+ in')
    end
        end
 else
    if falta_state==1
       disp('nada')
       casos=37;
       dibuja_mono(ejes_red,'trafo1.jpg');
              clear irele;
              load sinIsinF;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 
          elseif falta_state==0
        dibuja_mono(ejes_red,'falin.jpg');
       switch res_f
       case 1
          casos=38;
              clear irele;
              load fa0ohm;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t);   
       case 2
          casos=39;
              clear irele;
              load fa001oh;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t);   
       case 3
          casos=40;
              clear irele;
              load fa1ohm;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t);   
       case 4
          casos=41;
              clear irele;
              load fa100ohm;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t);   
         end   
       disp('falta interna')
    else
        dibuja_mono(ejes_red,'falex.jpg');
       switch res_f
       case 1
          casos=42;
              clear irele;
              load sinIf0;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 

       case 2
          casos=43;
              clear irele;
              load sinIf001;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 
       case 3
          casos=44;
              clear irele;
              load sinIf1;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 
       case 4
          casos=45;
              clear irele;
              load sinIf100;
              t=0:0.04/(length(irele)-1):0.04;
              dibuja_senal(ejes_senal,irele,7,'m',t); 
         end   
       disp('falta externa')
    end
end
