% Rel diferencial numrico con discriminacin por Ondculas
%
%     Este programa simula la proteccion diferencial de un transformador
%     mediante un rele diferencial numerico con discriminacion por ondiculas
%
% Funciones utilizadas:
%                         csenal.m
%                         ana_wave.m
%                         rele_cri.m
%                         calc_fft.m
%
clear all; close all; clc;
in_state=1;
falta_state=1;
an_f=1;
res_f=1;
tipo_w=1
nro_w=1
nro_nivel=1
irele=[];
d=[];
criterio=1;
%
%Definicin de  interfaz grfica
%
pantalla=get(0,'ScreenSize');
xw=pantalla(3); 
yw=pantalla(4);
vent1=figure('Position', [0 -0.03*yw xw yw], 'Menubar','none');
titulo=uicontrol(gcf,...
   'Style','text',...
   'String','RELE DIFERENCIAL NUMERICO CON DISCRIMINACION POR ONDICULAS',...
   'fontsize',11,...
   'foregroundcolor',[1 1 1],...
   'backgroundcolor',[0 0 0.78],...
   'fontweight','bold',...
   'Position',[xw/6 yw*0.95 0.67*xw 0.028*yw]);
set(titulo)
ejes_red = axes('units','pixels','Position',[xw/50 yw*0.65 0.25*xw 0.26*yw]);image(imread('trafo1.jpg'));   %Figura de la red
set(ejes_red,'linewidth',1.5,'TickLength',[0 0],'YTickLabel','','XTickLabel','')
ejes_senal=axes('units','pixels','Position',[xw/40 yw*0.1 0.25*xw 0.26*yw]);
set(ejes_senal,'Visible','off');

for i=1:(nro_nivel+1)
 ejes_wave(i)=axes('units','pixels','Position',[xw/40 yw*0.1 0.25*xw 0.26*yw]);
 set(ejes_wave(i),'Visible','off');
end
ejes_detalle = axes('units','pixels','Position',[xw/40 yw*0.1 0.25*xw 0.26*yw]);
set(ejes_detalle,'Visible','off');
ejes_cri = axes('units','pixels','Position',[xw/40 yw*0.1 0.25*xw 0.26*yw]);
set(ejes_cri,'Visible','off');
ejes_fourier = axes('units','pixels','Position',[xw/40 yw*0.1 0.25*xw 0.26*yw]);
set(ejes_fourier,'Visible','off');

%Ventanas para considerar el estudio de Inrush

   txt_inrush=uicontrol(gcf,...
   'Style','text',...
   'units','pixels','Position', [ xw/50 yw*0.6 0.12*xw 0.04*yw],...
   'string','Considerar Inrush');
       %Estudiar Inrush
       inrush_in=uicontrol(gcf,...
       'Style','radio',...
       'Position',[xw/50 yw*0.58 0.06*xw 0.04*yw] ,...
       'String','Si',...
       'Value',1,...
       'CallBack',[...
       'in_state= 1,'...
       'set(inrush_in,''Value'',1),'...
       'set(inrush_out,''Value'',0),']);

       %No estudiar Inrush
       inrush_out=uicontrol(gcf,...
       'Style','radio',...
       'Position', [0.08*xw yw*0.58 0.19*xw 0.04*yw],...
       'String','No',...
       'Value',0,...
       'CallBack',[...
       'in_state= 0,'...
       'set(inrush_out,''Value'',1),'...
       'set(inrush_in,''Value'',0),']);
 
 %Definicion menu pop-up para seleccionar angulo de conexin de la fuente
 
 txt_popan=uicontrol(gcf,...
   'Style','text',...
   'units','pixels','Position', [ xw/50+110 yw*0.6 0.12*xw+23 0.04*yw],...
   'string','Angulo de Conexin');
 popan=uicontrol(vent1,...
    'Style','popup',...
    'String','0 |30 |60 |90 ',...
    'Position',[0.14*xw+10 0.57*yw 0.07*xw+35 0.04*yw],...
    'CallBack', ['an_f = get(popan,''Value'')']);
  
%Menu para seleccionas el tipo de falta a estudiar

txt_falta=uicontrol(gcf,...
   'Style','text',...
   'units','pixels','Position', [ xw/50 yw*0.53 0.25*xw 0.04*yw],...
   'string','Considerar falta');
       %
       %No estudiar falta
       %
       sin_falta=uicontrol(gcf,...
       'Style','radio',...
       'Position',[xw/50 yw*0.51 0.08*xw 0.04*yw] ,...
       'String','Sin falta',...
       'Value',1,...
       'CallBack',[...
       'falta_state= 1,'...
       'set(sin_falta,''Value'',1),'...
       'set(falta_interna,''Value'',0),'...
       'set(falta_externa,''Value'',0),']);
       %
       %Estudiar falta interna
       %
       falta_interna=uicontrol(gcf,...
       'Style','radio',...
       'Position', [0.1*xw yw*0.51 0.09*xw 0.04*yw],...
       'String','Falta interna',...
       'Value',0,...
       'CallBack',[...
       'falta_state= 0,'...
       'set(sin_falta,''Value'',0),'...
       'set(falta_interna,''Value'',1),'...
       'set(falta_externa,''Value'',0),']);
       %
       %Estudiar falta externa
       %
       falta_externa=uicontrol(gcf,...
       'Style','radio',...
       'Position', [0.19*xw yw*0.51 0.08*xw 0.04*yw],...
       'String','Falta externa',...
       'Value',0,...
       'CallBack',[...
       'falta_state= -1,'...
       'set(sin_falta,''Value'',0),'...
       'set(falta_interna,''Value'',0),'...
       'set(falta_externa,''Value'',1),']);
 
 %Menu para seleccionar la resistencia de falta
 
 txt_popre=uicontrol(gcf,...
   'Style','text',...
   'units','pixels','Position', [ xw/50+80 yw*0.45 xw/50+155 0.06*yw],...
   'string','Resistencia de falta');
 popre=uicontrol(vent1,...
    'Style','popup',...
    'String','0 ohm|0.01 ohm|1.0 ohm|100 ohm',...
    'Position',[xw/50+120 0.44*yw 0.07*xw+35 0.04*yw],...
    'CallBack', ['res_f = get(popre,''Value'')']);
 
 %Texto para ventanas de eleccion de wavelet
 
 txt_wave=uicontrol(gcf,...
   'Style','text',...
   'units','pixels','Position', [ xw/50+280 yw*0.07 xw/50+70 0.05*yw],...
   'string','Ondicula');
 pop_wave=uicontrol(vent1,...
    'Style','popup',...
    'String','db|haar|sym',...
    'Position',[xw/50+370 0.07*yw xw/50+40 0.05*yw],...
    'CallBack', ['tipo_w = get(pop_wave,''Value'')']);
popwave_nro=uicontrol(vent1,...
    'Style','popup',...
    'String','1|2|3|4|5|6|7|8|9|10',...
    'Position',[xw/50+440 0.07*yw xw/50+20 0.05*yw],...
    'CallBack', ['nro_w = get(popwave_nro,''Value'')']);
txt_nivel=uicontrol(gcf,...
   'Style','text',...
   'units','pixels','Position', [ xw/50+280 yw*0.05 xw/50+70 0.03*yw],...
   'string','Nivel');
popwave_nivel=uicontrol(vent1,...
    'Style','popup',...
    'String','1|2|3|4|5|6|7|8|9|10',...
    'Position',[xw/50+370 0.04*yw xw/50+20 0.04*yw],...
    'CallBack', ['nro_nivel = get(popwave_nivel,''Value'')']);

%Botn tipo pushbutton para seleccionar la seal de estudio

senal=uicontrol(gcf,...
    'Style','push',...
    'Position',[xw/50+80 0.4*yw 0.07*xw 0.04*yw],...
    'String','Cargar seal',...
    'CallBack','[irele,t]=csenal(vent1,ejes_red,ejes_senal,in_state,falta_state,an_f,res_f,xw,yw,tipo_w,nro_nivel,nro_w,ejes_wave,ejes_detalle,ejes_cri,ejes_fourier);');
 
%Botn tipo pushbutton para el analisis wavelet

analizar=uicontrol(gcf,...
    'Style','push',...
    'Position',[xw/50+540 0.05*yw 0.07*xw 0.035*yw],...
    'String','Analizar',...
    'CallBack','[ejes_wave,ejes_detalle,ejes_cri,ejes_fourier,d]=ana_wave(irele,ejes_wave,ejes_detalle,ejes_cri,ejes_fourier,tipo_w,nro_w,nro_nivel,xw,yw,t);');

%Botn tipo pushbutton para Ejecutar el algoritmo del rele

analizar=uicontrol(gcf,...
    'Style','push',...
    'Position',[xw/50+925 0.53*yw 0.06*xw 0.04*yw],...
    'String','Ejecutar',...
    'CallBack','[ejes_cri, ejes_fourier]=rele_cri(d,ejes_cri,ejes_detalle,ejes_fourier,0,xw,yw,t);');

%Botn tipo pushbutton para evaluar la transformada rapida de Fourier de la seal de estudio

Fourier=uicontrol(gcf,...
    'Style','push',...
    'Position',[xw/50+925 0.05*yw 0.06*xw 0.035*yw],...
    'String','Fourier',...
    'CallBack','[ejes_fourier]=calc_fft(irele,ejes_fourier,xw,yw);');


  
