%
%rele_cri.m
%
% Funcion para discriminar la operacion del rele diferencial
%
%Parametros de entrada :
%         ejes_cri,ejes_detalle,ejes_fourier   : Ubicacion de ventanas
%         d        : Detalles del analisis wavelet
%         criterio : Criterio de operacion del rele
%         xw, yw   : Ubicacion de la ventana de resultados
%         t        : Intervalo de tiempo
%
%Parametros de salida :
%         ejes_cri,ejes_fourier : Ubicacion de ventanas
%
function [ejes_cri,ejes_fourier]=rele_cri(d,ejes_cri,ejes_detalle,ejes_fourier,criterio,xw,yw,t)
set(ejes_cri,'Visible','off');
axes(ejes_cri);
cla;
ttotal=0.04;
desfase=0.005;
tfinal=0.01;
tinicio=0;
npuntos=length(d(1,:));
thrvm=0.4;
thrvu=0.25;
axes(ejes_detalle);
set(gcf,'currentaxes',ejes_detalle);
cla;
plot(t,d(1,:),'r'); 
hold on

if criterio==1
    colores=['k' 'g' 'b' 'k' 'g' 'b' 'k'];
    for j=1:7
    tgrf(j)=tfinal;
   if tinicio==0
     puntoinicio=1;  
  else
     puntoinicio=fix(npuntos*tinicio/ttotal)-1;
 end
    puntofinal=fix(npuntos*tfinal/ttotal);
    cs=d(1,puntoinicio:puntofinal);
    picomax(j)=max(cs);
    ratio(j)=picomax(j)/picomax(1);
    plot([tinicio tfinal tfinal tinicio tinicio],[-(1+j*j/100)*picomax(1) -(1+j*j/100)*picomax(1)...
    (1+j*j/100)*picomax(1) (1+j*j/100)*picomax(1) -(1+j*j/100)*picomax(1)],colores(j),'linestyle',':');
    hold on
    tinicio=tinicio+desfase;
    tfinal=tfinal+desfase;
    cs=[];
end 
    ejes_cri = axes('units','pixels','Position',[(2/3)*xw+45 yw*0.34 0.28*xw 0.15*yw]);
    axes(ejes_cri);
    set(gcf,'currentaxes',ejes_cri);
    tgrf=[0 0.0099 tgrf];
    ratio=[0 0 ratio];
    x=[0;0.04];y=[thrvm;thrvm]; 
    plot([0 0.01 0.01 0 0],[-(1+1/100)*ratio(3) -(1+1/100)*ratio(3)...
    (1+1/100)*ratio(3) (1+1/100)*ratio(3) -(1+1/100)*ratio(3)],colores(1),'linestyle',':');
    hold on
    plot([desfase desfase+0.01 desfase+0.01 desfase desfase],[-(1+4/100)*ratio(3) -(1+1/100)*ratio(3)...
    (1+4/100)*ratio(3) (1+4/100)*ratio(3) -(1+4/100)*ratio(3)],colores(2),'linestyle',':');
    hold on
    plot(tgrf,ratio,'linewidth',2,'marker','d');
    axis([0,0.04,-0.01,1.2]);
    lt=line(x,y);
    set(lt,'color','red','linewidth',2,'linestyle','-.');
    set(ejes_cri,'fontsize',9,'linewidth',1);
    xlabel('[seg.]','HorizontalAlignment','left');
    title('Ratio de discriminacion Ventanas multiples','fontweight','bold','fontsize',10);
    in=text(0.025,0.7,'No actuar');
    set(in,'color','g','fontweight','bold');
    fa=text(0.025,0.14,'Falta:actuar');
    set(fa,'color','r','fontweight','bold');
else
    tcriterio=0.01;
    puntoinicio=1;
    plot([0 tcriterio tcriterio 0 0],[-1.1*max(d(1,:)) -1.1*max(d(1,:))...
    1.1*max(d(1,:)) 1.1*max(d(1,:)) -1.1*max(d(1,:))],'k','linestyle',':');
    hold on
    puntofinal=fix(npuntos*tcriterio/ttotal)
    cs=d(1,puntoinicio:puntofinal);
    indice=max(cs)/(sum(abs(cs))/2 );
    ejes_cri = axes('units','pixels','Position',[(2/3)*xw+45 yw*0.34 0.28*xw 0.15*yw]);
    axes(ejes_cri);
    set(gcf,'currentaxes',ejes_cri);
    x=[0;0.04];y=[thrvu;thrvu];
    plot(tcriterio,indice,'linewidth',2,'marker','d');
    axis([0,0.04,0,1]);
    lt=line(x,y);
    set(lt,'color','red','linewidth',2,'linestyle','-.');
    set(ejes_cri,'fontsize',9,'linewidth',1);
    xlabel('[seg.]','HorizontalAlignment','left');
    title('Indice de discriminacion Iratio','fontweight','bold','fontsize',10);
    in=text(0.025,0.7,'No actuar');
    set(in,'color','g','fontweight','bold');
    fa=text(0.025,0.14,'Falta:actuar');
    set(fa,'color','r','fontweight','bold');
end
  
   

